#include "planetinfodisplay.h"

QRectF PlanetInfoDisplay::boundingRect() const
{
    return QRectF(0.0f,0.0f,static_cast<float>(width),52);
}

void PlanetInfoDisplay::paint(QPainter* painter,const QStyleOptionGraphicsItem*,QWidget*)
{
    //BackGorund
    painter->setFont(QFont("Courier",8));
    QPen pen(Qt::darkGray);
    pen.setWidth(2);
    pen.setCapStyle(Qt::RoundCap);
    pen.setJoinStyle(Qt::RoundJoin);
    painter->setPen(pen);
    painter->setBrush(QBrush(QColor(10,10,10,190)));
    painter->drawRect(0,0,width,52);

    //Text
    painter->setPen(Qt::white);
    painter->drawText(2,10,shownName);
    painter->drawText(2,20,shownOwner);
    painter->drawText(2,30,shownProdction);
    painter->drawText(2,40,shownShipCount);
    painter->drawText(2,50,shownDefBonus);
}

int PlanetInfoDisplay::getWidth()
{
    return width;
}

void PlanetInfoDisplay::setData(QString name,QString owner,
                                int production,int shipCount,float defBonus)
{
    width = 1;
    shownName = QObject::tr("Name: %1").arg(name);
    shownOwner = QObject::tr("Owner: %1").arg(owner);
    shownProdction = QObject::tr("Production: %1").arg(production);
    shownShipCount = QObject::tr("Ships: %1").arg(shipCount);
    shownDefBonus = QObject::tr("Defens: %1").arg(defBonus);

    if(width < shownName.length()*8) width = shownName.length()*8;
    if(width < shownOwner.length()*8) width = shownOwner.length()*8;
    if(width < shownProdction.length()*8) width = shownProdction.length()*8;
    if(width < shownShipCount.length()*8) width = shownShipCount.length()*8;
    if(width < shownDefBonus.length()*8) width = shownDefBonus.length()*8;

    update();
}

PlanetInfoDisplay::PlanetInfoDisplay()
    :QGraphicsItem()
{
    width = 1;
    shownName = "none";
    shownOwner = "none";
    shownProdction = "none";
    shownShipCount = "none";
    shownDefBonus = "none";
}
