#ifndef PLANETITEM_H
#define PLANETITEM_H

#include <QObject>
#include <QGraphicsItem>
#include <QPixmap>
#include <QPainter>
#include <QGraphicsSceneMouseEvent>
#include <QGraphicsSceneHoverEvent>
#include <QKeyEvent>
#include "planetData.h"

class PlanetItem : public QObject, public QGraphicsItem
{
    Q_OBJECT
public:
    PlanetItem(QPixmap image,int id);
    QRectF boundingRect() const;
    void paint(QPainter* painter,const QStyleOptionGraphicsItem* o,QWidget* w);
    void setOwnerColor(QColor color);
    void mark();
    void unMark();
    void showShipCount();
    void hideShipCount();
    void setShipCount(int count);

protected:
    void mousePressEvent(QGraphicsSceneMouseEvent* event);
    void hoverEnterEvent(QGraphicsSceneHoverEvent* event);
    void hoverLeaveEvent(QGraphicsSceneHoverEvent* event);
    void keyPressEvent(QKeyEvent* event);

signals:
    void clicked(int id);
    void touched(int id,int x,int y);
    void unTouched();

private:
    QPixmap myImage;
    int myId;
    QColor ownerColor;
    bool marked;
    int shipCount;
    bool showCount;
};

#endif // PLANETITEM_H
