#include "serverthread.h"

void ServerThread::run()
{
    server = new QTcpServer(this);
    connect(server,SIGNAL(newConnection()),this,SLOT(incommingConnection()));
    
    server->listen(QHostAddress::Any,6666);

    if(!server->isListening())
    {
        emit serverCantListen();
        return;
    }

    emit serverAddress(server->serverAddress().toString());

    exec();
}

void ServerThread::stopWorking()
{
    server->close();
    this->exit(0);
}

void ServerThread::incommingConnection()
{
    QTcpSocket* newConnection = server->nextPendingConnection();
    if(newConnection)//connected
    {
        if(!gameStarted)//accept connections
        {
            emit playerConnected(newConnection);
        }
        else//refuse all new connections
        {
            newConnection->write(tr("Sorry the game has already been started.").toAscii());
            newConnection->disconnectFromHost();
        }
    }
}

void ServerThread::gameStart()
{
    gameStarted = true;
}

ServerThread::ServerThread()
    :QThread()
{
    gameStarted = false;
}
