#ifndef SERVERTHREAD_H
#define SERVERTHREAD_H

#include <QThread>
#include <QTcpServer>
#include <QTcpSocket>
#include <QStringList>

class ServerThread : public QThread
{
    Q_OBJECT
public:
    ServerThread();
    void run();
    void gameStart();
    void stopWorking();

private slots:
    void incommingConnection();

signals:
    void playerConnected(QTcpSocket* socket);
    void serverAddress(QString addres);
    void serverCantListen();

private:
    QTcpServer* server;
    QStringList connectedPlayers;
    bool gameStarted;
};

#endif // SERVERTHREAD_H
